<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>План обучения JavaScript</title>
    <style>
        body {
            background-color: antiquewhite;
        }
        table {
            width: 100%;
            border-collapse: collapse;
            background-color: white;
        }
        th, td {
            padding: 10px;
            text-align: left;
            border-bottom: 1px solid #ddd;
        }
        th {
            background-color: #f2f2f2;
        }
        input[type="checkbox"] {
            transform: scale(1.5);
            margin-right: 10px;
        }
        .bold {
            font-weight: bold;
        }
    </style>
</head>
<body>
<h1>План обучения JavaScript</h1>
<h2>Модуль 1: Основы JavaScript</h2>
<table id="module1">
    <tr>
        <th>№</th>
        <th>Тема</th>
        <th>Страница</th>
        <th>Выполнено</th>
    </tr>
</table>

<h2>Модуль 2: Работа с объектами и строками</h2>
<table id="module2">
    <tr>
        <th>№</th>
        <th>Тема</th>
        <th>Страница</th>
        <th>Выполнено</th>
    </tr>
</table>

<h2>Модуль 3: Расширенные темы JavaScript</h2>
<table id="module3">
    <tr>
        <th>№</th>
        <th>Тема</th>
        <th>Страница</th>
        <th>Выполнено</th>
    </tr>
</table>

<h2>Модуль 4: Работа с DOM</h2>
<table id="module4">
    <tr>
        <th>№</th>
        <th>Тема</th>
        <th>Страница</th>
        <th>Выполнено</th>
    </tr>
</table>

<script>
    const topics = [
        // Модуль 1: Основы JavaScript
        { module: "module1", number: 1, name: "Привет, мир! (в конце сайта сделать задачи)", link: "https://learn.javascript.ru/hello-world" },
        { module: "module1", number: 2, name: "Переменные (в конце сайта сделать задачи)", link: "https://learn.javascript.ru/variables" },
        { module: "module1", number: 3, name: "Переменные: let и const (в конце сайта сделать задачи)", link: "https://learn.javascript.ru/let-const" },
        { module: "module1", number: 4, name: "Типы данных (в конце сайта сделать задачи)", link: "https://learn.javascript.ru/types" },
        { module: "module1", number: 5, name: "Числа (в конце сайта сделать задачи)", link: "https://learn.javascript.ru/number" },
        { module: "module1", number: 6, name: "Преобразование типов (в конце сайта сделать задачи)", link: "https://learn.javascript.ru/type-conversions" },
        { module: "module1", number: 7, name: "Операторы сравнения (в конце сайта сделать задачи)", link: "https://learn.javascript.ru/comparison" },
        { module: "module1", number: 8, name: "Оператор if (в конце сайта сделать задачи)", link: "https://learn.javascript.ru/ifelse" },
        { module: "module1", number: 9, name: "Логические операторы (в конце сайта сделать задачи)", link: "https://learn.javascript.ru/logical-operators" },
        { module: "module1", number: 10, name: "Конструкция 'switch' (в конце сайта сделать задачи)", link: "https://learn.javascript.ru/switch" },
        { module: "module1", number: 11, name: "Циклы while и for (в конце сайта сделать задачи)", link: "https://learn.javascript.ru/while-for" },
        { module: "module1", number: 12, name: "Функции (в конце сайта сделать задачи)", link: "https://learn.javascript.ru/function-basics" },
        { module: "module1", number: 13, name: "Отладка в браузере (в конце сайта сделать задачи)", link: "https://learn.javascript.ru/debugging-chrome" },
// Модуль 2: Работа с объектами и строками
        { module: "module2", number: 14, name: "Объекты (в конце сайта сделать задачи)", link: "https://learn.javascript.ru/object" },
        { module: "module2", number: 15, name: "Работа с объектами (MDN) (в конце сайта сделать задачи)", link: "https://developer.mozilla.org/ru/docs/Web/JavaScript/Guide/Working_with_objects" },
        { module: "module2", number: 16, name: "Строки (в конце сайта сделать задачи)", link: "https://learn.javascript.ru/string" },
        { module: "module2", number: 17, name: "Дата и время (в конце сайта сделать задачи)", link: "https://learn.javascript.ru/datetime" },
        { module: "module2", number: 18, name: "Стрелочные функции (в конце сайта сделать задачи)", link: "https://learn.javascript.ru/arrow-functions-basics" },
// Модуль 3: Расширенные темы JavaScript
        { module: "module3", number: 19, name: "Остаточные параметры и оператор расширения", link: "https://learn.javascript.ru/rest-parameters-spread-operator" },
        { module: "module3", number: 20, name: "Браузерное окружение, спецификации", link: "https://learn.javascript.ru/browser-environment" },
// Модуль 4: Работа с DOM
        { module: "module4", number: 21, name: "DOM-дерево (в конце сайта сделать задачи)", link: "https://learn.javascript.ru/dom-nodes" },
        { module: "module4", number: 22, name: "Навигация по DOM-элементам (в конце сайта сделать задачи)", link: "https://learn.javascript.ru/dom-navigation" },
        { module: "module4", number: 23, name: "Поиск: getElement, querySelector (в конце сайта сделать задачи)", link: "https://learn.javascript.ru/searching-elements-dom" },
        { module: "module4", number: 24, name: "Атрибуты и свойства (в конце сайта сделать задачи)", link: "https://learn.javascript.ru/dom-attributes-and-properties" },
        { module: "module4", number: 25, name: "Изменение документа (в конце сайта сделать задачи)", link: "https://learn.javascript.ru/modifying-document" },
        { module: "module4", number: 26, name: "Стили и классы (в конце сайта сделать задачи)", link: "https://learn.javascript.ru/styles-and-classes" },
        { module: "module4", number: 27, name: "Размеры и прокрутка элементов (в конце сайта сделать задачи)", link: "https://learn.javascript.ru/size-and-scroll" },
        { module: "module4", number: 28, name: "Координаты (в конце сайта сделать задачи)", link: "https://learn.javascript.ru/coordinates" },
        { module: "module4", number: 29, name: "Введение в браузерные события (в конце сайта сделать задачи)", link: "https://learn.javascript.ru/introduction-browser-events" },
        { module: "module4", number: 30, name: "Основы событий мыши (в конце сайта сделать задачи)", link: "https://learn.javascript.ru/mouse-events-basics" },
        { module: "module4", number: 31, name: "Страница: DOMContentLoaded, load, beforeunload, unload (в конце сайта сделать задачи)", link: "https://learn.javascript.ru/onload-ondomcontentloaded" },
        { module: "module4", number: 32, name: "Клавиатура: keydown и keyup (в конце сайта сделать задачи)", link: "https://learn.javascript.ru/keyboard-events" },
        { module: "module4", number: 33, name: "Размеры и прокрутка страницы (в конце сайта сделать задачи)", link: "https://learn.javascript.ru/metrics-window" },
        { module: "module4", number: 34, name: "Действия браузера по умолчанию (в конце сайта сделать задачи)", link: "https://learn.javascript.ru/default-browser-action" },
        { module: "module4", number: 35, name: "Делегирование событий (в конце сайта сделать задачи)", link: "https://learn.javascript.ru/event-delegation" },
        { module: "module4", number: 36, name: "Планирование: setTimeout и setInterval (в конце сайта сделать задачи)", link: "https://learn.javascript.ru/settimeout-setinterval" },
        { module: "module4", number: 37, name: "LocalStorage, sessionStorage (в конце сайта сделать задачи)", link: "https://learn.javascript.ru/localstorage" }
    ];

    topics.forEach(topic => {
        const table = document.getElementById(topic.module);
        const row = table.insertRow();
        row.innerHTML = `
                <td>${topic.number}</td>
                <td>${topic.name.includes('(в конце сайта сделать задачи)') ? topic.name.replace('(в конце сайта сделать задачи)', '</span><span class="bold">(в конце сайта сделать задачи)</span>') : `<span class="bold">${topic.name}</span>`}</td>
                <td><a href="${topic.link}" target="_blank">${topic.link}</a></td>
                <td><input type="checkbox" ${localStorage.getItem(topic.module + topic.number) === 'true' ? 'checked' : ''}></td>
            `;
        const checkbox = row.querySelector('input[type="checkbox"]');
        checkbox.addEventListener('change', () => {
            localStorage.setItem(topic.module + topic.number, checkbox.checked);
        });
    });
</script>
</body>
</html>
